﻿using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace P2Pdemo.Models
{
    public class CommHelper : ControllerBase
    {
        /// <summary>
        /// 获取请求Body,并转换位JObject类型
        /// </summary>
        public Dictionary<string, object> GetParameter()
        {
            try
            {
                string param = string.Empty;
                using (var s = new System.IO.StreamReader(Request.Body))
                {
                    param = s.ReadToEnd();
                }
                Dictionary<string, object> item = ToObject<Dictionary<string, object>>(param);
                return item;
            }
            catch (Exception)
            {
                return null;
            }
        }

        public static T ToObject<T>(string json)
        {
            try
            {
                T model = JsonConvert.DeserializeObject<T>(json);
                return model;
            }
            catch (Exception)
            {
                return default(T);
            }
        }

        #region AES解密
        /// <summary>
        /// AES解密
        /// </summary>
        /// <param name="param">deviceno、timestemp、sign、data</param>
        /// <param name="cr">返回错误</param>
        /// <returns></returns>
        public static void AESDataParam(ref dynamic param)
        {
            if (param.data.ToString() != "" && param.data.ToString() != "{}")
                param.data = AESHelper.AesDecrypt(System.Web.HttpUtility.UrlDecode(param.data.ToString()));
        }

        /// <summary>
        /// AES解密
        /// </summary>
        /// <param name="param">deviceno、timestemp、sign、data</param>
        /// <param name="cr">返回错误</param>
        /// <returns></returns>
        public static void AESDataParam(ref Models.ParamModel param)
        {
            if (param.data.ToString() != "" && param.data.ToString() != "{}")
                param.data = AESHelper.AesDecrypt(System.Web.HttpUtility.UrlDecode(param.data.ToString()));
        }
        /// <summary>
        /// AES解密
        /// </summary>
        /// <param name="param">deviceno、timestemp、sign、data</param>
        /// <param name="cr">返回错误</param>
        /// <returns></returns>
        public static void AESDataParam(ref Models.ParkParamModel param)
        {
            if (param.data.ToString() != "" && param.data.ToString() != "{}")
                param.data = AESHelper.AesDecrypt(System.Web.HttpUtility.UrlDecode(param.data.ToString()));
        }
        #endregion
    }
}
